/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../../common";

export declare namespace OspDataTypes {
  export type SetPluginDataStruct = {
    isEnable: PromiseOrValue<boolean>;
    pluginAddress: PromiseOrValue<string>;
    tokenAddress: PromiseOrValue<string>;
    amount: PromiseOrValue<BigNumberish>;
  };

  export type SetPluginDataStructOutput = [
    boolean,
    string,
    string,
    BigNumber
  ] & {
    isEnable: boolean;
    pluginAddress: string;
    tokenAddress: string;
    amount: BigNumber;
  };
}

export interface IGovernanceLogicInterface extends utils.Interface {
  functions: {
    "getBaseURI()": FunctionFragment;
    "getCollectNFTImpl()": FunctionFragment;
    "getCommunityNFT()": FunctionFragment;
    "getFollowSBTImpl()": FunctionFragment;
    "getGovernance()": FunctionFragment;
    "getJoinNFTImpl()": FunctionFragment;
    "getState()": FunctionFragment;
    "initialize(string,string,address,address,address,address,address)": FunctionFragment;
    "isCollectModuleWhitelisted(address)": FunctionFragment;
    "isCommunityConditionWhitelisted(address)": FunctionFragment;
    "isFollowModuleWhitelisted(address)": FunctionFragment;
    "isJoinModuleWhitelisted(address)": FunctionFragment;
    "isReferenceModuleWhitelisted(address)": FunctionFragment;
    "isReserveCommunityHandle(string)": FunctionFragment;
    "isSuperCommunityCreatorWhitelisted(address)": FunctionFragment;
    "isTokenWhitelisted(address)": FunctionFragment;
    "reserveCommunityHandle(string,bool)": FunctionFragment;
    "setBaseURI(string)": FunctionFragment;
    "setEmergencyAdmin(address)": FunctionFragment;
    "setGovernance(address)": FunctionFragment;
    "setPlugin((bool,address,address,uint256))": FunctionFragment;
    "setState(uint8)": FunctionFragment;
    "updateMetadata()": FunctionFragment;
    "whitelistCollectModule(address,bool)": FunctionFragment;
    "whitelistCommunityCondition(address,bool)": FunctionFragment;
    "whitelistFollowModule(address,bool)": FunctionFragment;
    "whitelistJoinModule(address,bool)": FunctionFragment;
    "whitelistReferenceModule(address,bool)": FunctionFragment;
    "whitelistSuperCommunityCreator(address,bool)": FunctionFragment;
    "whitelistToken(address,bool)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "getBaseURI"
      | "getCollectNFTImpl"
      | "getCommunityNFT"
      | "getFollowSBTImpl"
      | "getGovernance"
      | "getJoinNFTImpl"
      | "getState"
      | "initialize"
      | "isCollectModuleWhitelisted"
      | "isCommunityConditionWhitelisted"
      | "isFollowModuleWhitelisted"
      | "isJoinModuleWhitelisted"
      | "isReferenceModuleWhitelisted"
      | "isReserveCommunityHandle"
      | "isSuperCommunityCreatorWhitelisted"
      | "isTokenWhitelisted"
      | "reserveCommunityHandle"
      | "setBaseURI"
      | "setEmergencyAdmin"
      | "setGovernance"
      | "setPlugin"
      | "setState"
      | "updateMetadata"
      | "whitelistCollectModule"
      | "whitelistCommunityCondition"
      | "whitelistFollowModule"
      | "whitelistJoinModule"
      | "whitelistReferenceModule"
      | "whitelistSuperCommunityCreator"
      | "whitelistToken"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "getBaseURI",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getCollectNFTImpl",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getCommunityNFT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getFollowSBTImpl",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getGovernance",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getJoinNFTImpl",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "getState", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "initialize",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "isCollectModuleWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isCommunityConditionWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isFollowModuleWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isJoinModuleWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isReferenceModuleWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isReserveCommunityHandle",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isSuperCommunityCreatorWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isTokenWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "reserveCommunityHandle",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "setBaseURI",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setEmergencyAdmin",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setGovernance",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setPlugin",
    values: [OspDataTypes.SetPluginDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "setState",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "updateMetadata",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistCollectModule",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistCommunityCondition",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistFollowModule",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistJoinModule",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistReferenceModule",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistSuperCommunityCreator",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistToken",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;

  decodeFunctionResult(functionFragment: "getBaseURI", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getCollectNFTImpl",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getCommunityNFT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getFollowSBTImpl",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getGovernance",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getJoinNFTImpl",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "getState", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "isCollectModuleWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isCommunityConditionWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isFollowModuleWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isJoinModuleWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isReferenceModuleWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isReserveCommunityHandle",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isSuperCommunityCreatorWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isTokenWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "reserveCommunityHandle",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setBaseURI", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setEmergencyAdmin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setGovernance",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setPlugin", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setState", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "updateMetadata",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistCollectModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistCommunityCondition",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistFollowModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistJoinModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistReferenceModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistSuperCommunityCreator",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistToken",
    data: BytesLike
  ): Result;

  events: {
    "BatchMetadataUpdate(uint256,uint256)": EventFragment;
    "MetadataUpdate(uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "BatchMetadataUpdate"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "MetadataUpdate"): EventFragment;
}

export interface BatchMetadataUpdateEventObject {
  _fromTokenId: BigNumber;
  _toTokenId: BigNumber;
}
export type BatchMetadataUpdateEvent = TypedEvent<
  [BigNumber, BigNumber],
  BatchMetadataUpdateEventObject
>;

export type BatchMetadataUpdateEventFilter =
  TypedEventFilter<BatchMetadataUpdateEvent>;

export interface MetadataUpdateEventObject {
  _tokenId: BigNumber;
}
export type MetadataUpdateEvent = TypedEvent<
  [BigNumber],
  MetadataUpdateEventObject
>;

export type MetadataUpdateEventFilter = TypedEventFilter<MetadataUpdateEvent>;

export interface IGovernanceLogic extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: IGovernanceLogicInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    getBaseURI(overrides?: CallOverrides): Promise<[string]>;

    getCollectNFTImpl(overrides?: CallOverrides): Promise<[string]>;

    getCommunityNFT(overrides?: CallOverrides): Promise<[string]>;

    getFollowSBTImpl(overrides?: CallOverrides): Promise<[string]>;

    getGovernance(overrides?: CallOverrides): Promise<[string]>;

    getJoinNFTImpl(overrides?: CallOverrides): Promise<[string]>;

    getState(overrides?: CallOverrides): Promise<[number]>;

    initialize(
      name: PromiseOrValue<string>,
      symbol: PromiseOrValue<string>,
      newGovernance: PromiseOrValue<string>,
      collectNFTImpl: PromiseOrValue<string>,
      followSBTImpl: PromiseOrValue<string>,
      joinNFTImpl: PromiseOrValue<string>,
      communityNFT: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    isCollectModuleWhitelisted(
      collectModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isCommunityConditionWhitelisted(
      condition: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isFollowModuleWhitelisted(
      followModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isJoinModuleWhitelisted(
      joinModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isReferenceModuleWhitelisted(
      referenceModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isReserveCommunityHandle(
      handle: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isSuperCommunityCreatorWhitelisted(
      communityCreator: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isTokenWhitelisted(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    reserveCommunityHandle(
      handle: PromiseOrValue<string>,
      isReserve: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setBaseURI(
      baseURI: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setEmergencyAdmin(
      newEmergencyAdmin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setGovernance(
      newGovernance: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setPlugin(
      plugin: OspDataTypes.SetPluginDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setState(
      newState: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    updateMetadata(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistCollectModule(
      collectModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistCommunityCondition(
      condition: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistFollowModule(
      followModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistJoinModule(
      joinModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistReferenceModule(
      referenceModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistSuperCommunityCreator(
      communityCreator: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    whitelistToken(
      token: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  getBaseURI(overrides?: CallOverrides): Promise<string>;

  getCollectNFTImpl(overrides?: CallOverrides): Promise<string>;

  getCommunityNFT(overrides?: CallOverrides): Promise<string>;

  getFollowSBTImpl(overrides?: CallOverrides): Promise<string>;

  getGovernance(overrides?: CallOverrides): Promise<string>;

  getJoinNFTImpl(overrides?: CallOverrides): Promise<string>;

  getState(overrides?: CallOverrides): Promise<number>;

  initialize(
    name: PromiseOrValue<string>,
    symbol: PromiseOrValue<string>,
    newGovernance: PromiseOrValue<string>,
    collectNFTImpl: PromiseOrValue<string>,
    followSBTImpl: PromiseOrValue<string>,
    joinNFTImpl: PromiseOrValue<string>,
    communityNFT: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  isCollectModuleWhitelisted(
    collectModule: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isCommunityConditionWhitelisted(
    condition: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isFollowModuleWhitelisted(
    followModule: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isJoinModuleWhitelisted(
    joinModule: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isReferenceModuleWhitelisted(
    referenceModule: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isReserveCommunityHandle(
    handle: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isSuperCommunityCreatorWhitelisted(
    communityCreator: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isTokenWhitelisted(
    token: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  reserveCommunityHandle(
    handle: PromiseOrValue<string>,
    isReserve: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setBaseURI(
    baseURI: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setEmergencyAdmin(
    newEmergencyAdmin: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setGovernance(
    newGovernance: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setPlugin(
    plugin: OspDataTypes.SetPluginDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setState(
    newState: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  updateMetadata(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistCollectModule(
    collectModule: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistCommunityCondition(
    condition: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistFollowModule(
    followModule: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistJoinModule(
    joinModule: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistReferenceModule(
    referenceModule: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistSuperCommunityCreator(
    communityCreator: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  whitelistToken(
    token: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    getBaseURI(overrides?: CallOverrides): Promise<string>;

    getCollectNFTImpl(overrides?: CallOverrides): Promise<string>;

    getCommunityNFT(overrides?: CallOverrides): Promise<string>;

    getFollowSBTImpl(overrides?: CallOverrides): Promise<string>;

    getGovernance(overrides?: CallOverrides): Promise<string>;

    getJoinNFTImpl(overrides?: CallOverrides): Promise<string>;

    getState(overrides?: CallOverrides): Promise<number>;

    initialize(
      name: PromiseOrValue<string>,
      symbol: PromiseOrValue<string>,
      newGovernance: PromiseOrValue<string>,
      collectNFTImpl: PromiseOrValue<string>,
      followSBTImpl: PromiseOrValue<string>,
      joinNFTImpl: PromiseOrValue<string>,
      communityNFT: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    isCollectModuleWhitelisted(
      collectModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isCommunityConditionWhitelisted(
      condition: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isFollowModuleWhitelisted(
      followModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isJoinModuleWhitelisted(
      joinModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isReferenceModuleWhitelisted(
      referenceModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isReserveCommunityHandle(
      handle: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isSuperCommunityCreatorWhitelisted(
      communityCreator: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isTokenWhitelisted(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    reserveCommunityHandle(
      handle: PromiseOrValue<string>,
      isReserve: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    setBaseURI(
      baseURI: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setEmergencyAdmin(
      newEmergencyAdmin: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setGovernance(
      newGovernance: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setPlugin(
      plugin: OspDataTypes.SetPluginDataStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    setState(
      newState: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<void>;

    updateMetadata(overrides?: CallOverrides): Promise<void>;

    whitelistCollectModule(
      collectModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistCommunityCondition(
      condition: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistFollowModule(
      followModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistJoinModule(
      joinModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistReferenceModule(
      referenceModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistSuperCommunityCreator(
      communityCreator: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;

    whitelistToken(
      token: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    "BatchMetadataUpdate(uint256,uint256)"(
      _fromTokenId?: null,
      _toTokenId?: null
    ): BatchMetadataUpdateEventFilter;
    BatchMetadataUpdate(
      _fromTokenId?: null,
      _toTokenId?: null
    ): BatchMetadataUpdateEventFilter;

    "MetadataUpdate(uint256)"(_tokenId?: null): MetadataUpdateEventFilter;
    MetadataUpdate(_tokenId?: null): MetadataUpdateEventFilter;
  };

  estimateGas: {
    getBaseURI(overrides?: CallOverrides): Promise<BigNumber>;

    getCollectNFTImpl(overrides?: CallOverrides): Promise<BigNumber>;

    getCommunityNFT(overrides?: CallOverrides): Promise<BigNumber>;

    getFollowSBTImpl(overrides?: CallOverrides): Promise<BigNumber>;

    getGovernance(overrides?: CallOverrides): Promise<BigNumber>;

    getJoinNFTImpl(overrides?: CallOverrides): Promise<BigNumber>;

    getState(overrides?: CallOverrides): Promise<BigNumber>;

    initialize(
      name: PromiseOrValue<string>,
      symbol: PromiseOrValue<string>,
      newGovernance: PromiseOrValue<string>,
      collectNFTImpl: PromiseOrValue<string>,
      followSBTImpl: PromiseOrValue<string>,
      joinNFTImpl: PromiseOrValue<string>,
      communityNFT: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    isCollectModuleWhitelisted(
      collectModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isCommunityConditionWhitelisted(
      condition: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isFollowModuleWhitelisted(
      followModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isJoinModuleWhitelisted(
      joinModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isReferenceModuleWhitelisted(
      referenceModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isReserveCommunityHandle(
      handle: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isSuperCommunityCreatorWhitelisted(
      communityCreator: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isTokenWhitelisted(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    reserveCommunityHandle(
      handle: PromiseOrValue<string>,
      isReserve: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setBaseURI(
      baseURI: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setEmergencyAdmin(
      newEmergencyAdmin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setGovernance(
      newGovernance: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setPlugin(
      plugin: OspDataTypes.SetPluginDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setState(
      newState: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    updateMetadata(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistCollectModule(
      collectModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistCommunityCondition(
      condition: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistFollowModule(
      followModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistJoinModule(
      joinModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistReferenceModule(
      referenceModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistSuperCommunityCreator(
      communityCreator: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    whitelistToken(
      token: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    getBaseURI(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getCollectNFTImpl(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getCommunityNFT(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getFollowSBTImpl(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getGovernance(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getJoinNFTImpl(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getState(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    initialize(
      name: PromiseOrValue<string>,
      symbol: PromiseOrValue<string>,
      newGovernance: PromiseOrValue<string>,
      collectNFTImpl: PromiseOrValue<string>,
      followSBTImpl: PromiseOrValue<string>,
      joinNFTImpl: PromiseOrValue<string>,
      communityNFT: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    isCollectModuleWhitelisted(
      collectModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isCommunityConditionWhitelisted(
      condition: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isFollowModuleWhitelisted(
      followModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isJoinModuleWhitelisted(
      joinModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isReferenceModuleWhitelisted(
      referenceModule: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isReserveCommunityHandle(
      handle: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isSuperCommunityCreatorWhitelisted(
      communityCreator: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isTokenWhitelisted(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    reserveCommunityHandle(
      handle: PromiseOrValue<string>,
      isReserve: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setBaseURI(
      baseURI: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setEmergencyAdmin(
      newEmergencyAdmin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setGovernance(
      newGovernance: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setPlugin(
      plugin: OspDataTypes.SetPluginDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setState(
      newState: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    updateMetadata(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistCollectModule(
      collectModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistCommunityCondition(
      condition: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistFollowModule(
      followModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistJoinModule(
      joinModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistReferenceModule(
      referenceModule: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistSuperCommunityCreator(
      communityCreator: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    whitelistToken(
      token: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
